/* Unoptimized version. Draws a Julia picture. Check the code for variables
   to modify if you want other pictures. */

#include <graphics.h>

main()
{
  int g_driver = 9, g_mode = 2; /* VGA-16 col, 640x480 */
  int count, i;
  float r0, r1, i0, i1, zreal, zimag, ztemp, zsize, m, n, cr, ci;

  /* Set up the graphics and colors. */

  initgraph(&g_driver, &g_mode, "");

  for(i = 0; i < 16; ++i)
  {
    setrgbpalette(i,0,i*2,i*4);
    setpalette(i,i);
  }

  /* Change these values for different parts of the current Julia Set. */

  r0 = -2.0; r1 = 2.0;
  i0 = 1.5; i1 = -1.5;

  /* Change these values for different Julia Sets. Check out JULIA.EXS for
     some examples. */

  cr = 0.32; ci = 0.043;

  for(n = 0; n < 480; ++n)
  {
    for(m = 0; m < 480; ++m)
    {
      zreal = r0 + ((r1-r0)*m)/480;
      zimag = i0 + ((i1-i0)*n)/480;

      for(count = zsize = 0; ((count < 256) && (zsize < 10000.0)); ++count)
      {
        ztemp = zreal;
        zreal = zreal*zreal - zimag*zimag + cr;
        zimag = 2*ztemp*zimag + ci;
        zsize = zreal*zreal + zimag*zimag;
      }

      if (count != 256)
        putpixel(m+80, n, count%15 + 1);

      if (kbhit())
      {
        closegraph();
        return(0); /* Yes, close up and leave. */
      }
    }
  }
  /* Picture done. Wait for key, then shut down the graphics and leave
     the program. */
  getch();
  closegraph();
  return(0);
}

